"""Solution of Exercise Lecture 4:

The file ~rschaaf/mobydick.txt contains the complete text of Herman Melville's
"Moby Dick" (Thanks to the Project Gutenberg www.gutenberg.org)

Find out which the 10 most frequent words in the novel are. Please make sure
that your statistics is not affected by interpunction and letter case!
"""



# Total number of words:
numWords = 0


# Read file and count occurences of the different words:
wordcounts = {}    # Key: string word; Value: int word count

punctuation = ".!?,;:-\)\(\"'" # Special characters

infile = open("mobydick.txt")
for line in infile:
    words = line.split()
    for word in words:
        # Handle (leading and trailing) special characters:
        cleanWord = word.strip(punctuation).lower()
        if cleanWord:
            numWords += 1
            if not wordcounts.has_key(cleanWord):
                wordcounts[cleanWord] = 0
            wordcounts[cleanWord] += 1
infile.close()


# Invert the wordcounts dictionary: 
wordstat = {} # Key: int word count; Value: list of strings words
for word in wordcounts.keys():
    count = wordcounts[word]
    if not wordstat.has_key(count):
        wordstat[count] = []
    wordstat[count].append(word)


# Produce sorted output:
scounts = sorted(wordstat.keys())
scounts.reverse()
iWord = 0
for count in scounts[:50]:
    words = wordstat[count]
    for word in words:
        iWord += 1
        print "%4d\t%s\t%5d / %d" % (iWord, word, count, numWords)



    

